---
- name: List subnets
  uri:
    url: "https://{{ ibmcloud_vpc_region }}.iaas.cloud.ibm.com/v1/subnets?version={{ ibmcloud_api_version }}&generation={{ ibmcloud_vpc_generation }}"
    method: GET
    headers:
      Authorization: "Bearer {{ ibmcloud_iam_token }}"
  register: api_output
  delegate_to: localhost

- name: Set subnet to the first one available if none has been provided
  when: vps_subnet is undefined
  vars:
    api_query: "subnets[?vpc.name=='{{ ibmcloud_vpc }}'].name"
  loop: "{{ api_output.json | json_query(api_query) }}"
  set_fact:
    vps_subnet: "{{ item }}"
  delegate_to: localhost

- name: Set subnet name to net01 if no subnet exists
  when: vps_subnet is undefined
  set_fact:
    vps_subnet: "net01"

- name: Store subnet ID from existing subnet
  vars:
    api_query: "subnets[?name=='{{ vps_subnet }}'].id"
  loop: "{{ api_output.json | json_query(api_query) }}"
  set_fact:
    subnet_id: "{{ item }}"
  delegate_to: localhost
  when: api_output is search(vps_subnet)

- name: Create subnet
  uri:
    url: "https://{{ ibmcloud_vpc_region }}.iaas.cloud.ibm.com/v1/subnets?version={{ ibmcloud_api_version }}&generation={{ ibmcloud_vpc_generation }}"
    method: POST
    body: " {\"name\":\"{{ vps_subnet }}\",\"ipv4_cidr_block\":\"10.243.0.0/24\",\"ip_version\":\"ipv4\",\"zone\":{\"name\":\"{{ vpc_zone }}\"},\"vpc\":{\"id\":\"{{ vpc_id }}\"},\"public_gateway\":null,\"network_acl\":null}"
    headers:
      Authorization: "Bearer {{ ibmcloud_iam_token }}"
    status_code: [200, 201]
  register: api_output
  delegate_to: localhost
  run_once: true
  when: subnet_id is not defined

- name: Store subnet ID
  set_fact:
    subnet_id: "{{ api_output.json.id }}"
  when: subnet_id is not defined

- pause:
    prompt: "Waiting a while to let the subnet create, should replace this with a loop later"
    seconds: 30
